/**********************************************************************************
CH395 TCP/IP Эӿ
Socket0UDP Serverģʽ
TMD Send from Rick and Morty using Interrupt!
**********************************************************************************/

/* ͷļ*/
#include "debug.h"
#include "stdio.h"
#include "string.h"
#include "../PUB/CH395INC.H"
#include "CH395.H"

/**********************************************************************************
/*
CH395_OP_INTERFACE_MODEΪ1-5
1Ӳ߲ӷʽ
2ģⲢӷʽ
3: ӲSPIӷʽ
4: ģSPIʽ
5: Ӳ첽ӷʽ
*/
#define   CH395_OP_INTERFACE_MODE             3
#if   (CH395_OP_INTERFACE_MODE == 1)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_HW.C"
#elif (CH395_OP_INTERFACE_MODE == 2)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 3)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_HW.H"
#elif (CH395_OP_INTERFACE_MODE == 4)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 5)                                 /* SEL = 1, TX = 1*/
#include "../PUB/CH395UART.H"
#else
#error "Please Select Correct Communication Interface "
#endif

/**********************************************************************************/
/* ļ */
#include "../PUB/CH395CMD.H"

#define  CH395_INT_WIRE    GPIO_ReadInputDataBit(GPIOA,GPIO_Pin_0)    /* CH395INT# */
#define  CH395_DEBUG                1

/* ñ */
UINT8  socket_buff[8][512];                                      /* ݻ */
struct _SOCK_INF sockinf[8];                                            /* SocketϢ */
struct _CH395_SYS CH395Inf;                                          /* CH395Ϣ */

/* CH395ض */
const UINT8 CH395IPAddr[4] = {192,168,31,39};                        /* CH395IPַ */
const UINT8 CH395GWIPAddr[4] = {192,168,31,1};                        /* CH395 */
const UINT8 CH395IPMask[4] = {255,255,255,0};                        /* CH395 */

/* socket ض*/
const UINT8  BroadcastIP[4] = {255,255,255,255};                 /* UDP㲥ַ */
//const UINT16 Socket0DesPort = 6003;//⣬Բ                             /* Socket 0ĿĶ˿ */
const UINT16 Socket0SourPort = 6000;//395鲥Ķ˿                             /* Socket 0Դ˿ */
//const UINT16 Socket1DesPort = 6005;//⣬Բ                              /* Socket 1ĿĶ˿ */
const UINT16 Socket1SourPort = 7000;//395鲥Ķ˿                             /* Socket 1Դ˿ */

//MultiMacǰֽڹ̶Ϊ1 0 5eֽMulticastIPĺֽһһӦ
/* ಥIPϢ */
UINT8  MulticastIP_1[4] = {239,1,1,2};                             /* ಥIPַ */
UINT8  MultiMac_1[6]    = {1,0,0x5e,1,1,2};                        /* ӦಥMacַ */
UINT8  MulticastIP_2[4] = {0};                             /* ಥIPַ */
UINT8  MultiMac_2[6]    = {0};                        /* ӦಥMacַ */
UINT32 Hash0 = 0,Hash1 = 0;
//Կͻ  
//const UINT8 CH395IPAddr[4] = {192,168,168,39};
//const UINT8 CH395GWIPAddr[4] = {192,168,168,1};
//const UINT8 CH395IPMask[4] = {255,255,255,0};
//const UINT8  BroadcastIP[4] = {255,255,255,255};
//const UINT16 Socket0DesPort = 6003;
//const UINT16 Socket0SourPort = 9001;
//UINT8  MulticastIP_1[4] = {224,192,168,168};
//UINT8  MultiMac_1[6]    = {1,0,0x5e,0x40,0xa8,0xa8};//鲥淶
//UINT8  MultiMac_1[6]    = {1,0,0x5e,192,168,168};//鲥淶

//Կͻ  дع
//const UINT8 CH395IPAddr[4]   = {168,190,76,13};
//const UINT8 CH395GWIPAddr[4] = {168,190,76,1};
//const UINT8 CH395IPMask[4]   = {255,255,255,0};
//const UINT8  BroadcastIP[4]  = {255,255,255,255};
//const UINT16 Socket0DesPort  = 5708;
//const UINT16 Socket0SourPort = 5708;
//UINT8 MulticastIP_1[4]       = {225,0,76,51};
//UINT8 MultiMac_1[6]          = {1,0,0x5e,0,76,51};

/**********************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ룬ͣ
* Input          : iError
* Output         : None
* Return         : None
**********************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CMD_ERR_SUCCESS) return;                           /* ɹ */
#if CH395_DEBUG
    printf("Error: %02X\n", (UINT16)iError);                         /* ʾ */
#endif
    while ( 1 )
    {
        Delay_Ms(200);
        Delay_Ms(200);
    }
}

/**********************************************************************************
* Function Name  : InitCH395InfParam
* Description    : ʼCH395Inf
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitCH395InfParam(void)
{
    memset(&CH395Inf,0,sizeof(CH395Inf));                            /* CH395Infȫ*/
    memcpy(CH395Inf.IPAddr,CH395IPAddr,sizeof(CH395IPAddr));         /* IPַдCH395Inf */
    memcpy(CH395Inf.GWIPAddr,CH395GWIPAddr,sizeof(CH395GWIPAddr));   /* IPַдCH395Inf */
    memcpy(CH395Inf.MASKAddr,CH395IPMask,sizeof(CH395IPMask));       /* дCH395Inf */
}

/**********************************************************************************
* Function Name  : InitSocketParam
* Description    : ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitSocketParam(void)
{
    memset(&sockinf[0],0,sizeof(sockinf[0]));                      /* SockInf[0]ȫ*/
    memcpy(&sockinf[0].IPAddr, BroadcastIP,sizeof(BroadcastIP));   /* UDP SERVERܣ轫ĿIPΪ㲥ַ255.255.255.255 */
//    sockinf[0].DesPort = Socket0DesPort;                           /* ĿĶ˿ */
    sockinf[0].SourPort= Socket0SourPort;                          /* Դ˿ */
    sockinf[0].ProtoType=PROTO_TYPE_UDP;                           /* UDPģʽ */

    memset(&sockinf[1],0,sizeof(sockinf[1]));                      /* SockInf[0]ȫ*/
    memcpy(&sockinf[1].IPAddr, BroadcastIP,sizeof(BroadcastIP));   /* UDP SERVERܣ轫ĿIPΪ㲥ַ255.255.255.255 */
//    sockinf[1].DesPort = Socket1DesPort;                           /* ĿĶ˿ */
    sockinf[1].SourPort= Socket1SourPort;                          /* Դ˿ */
    sockinf[1].ProtoType=PROTO_TYPE_UDP;                           /* UDPģʽ */
}

/**********************************************************************************
* Function Name  : CH395SocketInitOpen
* Description    : CH395 socket ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInitOpen(void)
{
    UINT8 i;

    /* socket 0ΪUDPģʽ */
    CH395SetSocketDesIP(0,sockinf[0].IPAddr);                        /* socket 0ĿIPַ */
    CH395SetSocketProtType(0,sockinf[0].ProtoType);                        /* socket 0Э */
//    CH395SetSocketDesPort(0,sockinf[0].DesPort);                     /* socket 0ĿĶ˿ */
    CH395SetSocketSourPort(0,sockinf[0].SourPort);                   /* socket 0Դ˿ */
    i = CH395OpenSocket(0);                                          /* socket 0 */
    mStopIfError(i);

    CH395SetSocketDesIP(1,sockinf[1].IPAddr);                        /* socket 0ĿIPַ */
    CH395SetSocketProtType(1,sockinf[1].ProtoType);                        /* socket 0Э */
//    CH395SetSocketDesPort(1,sockinf[1].DesPort);                     /* socket 0ĿĶ˿ */
    CH395SetSocketSourPort(1,sockinf[1].SourPort);                   /* socket 0Դ˿ */
    i = CH395OpenSocket(1);                                          /* socket 0 */
    mStopIfError(i);
}

/*********************************************************************************
* Function Name  : Socket_R_S_Buf_Modify
* Description    : Socketշ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void Socket_R_S_Buf_Modify(void )
{
    CH395SetSocketRecvBuf(0,0,4);                                     /* Socket 0 ջ4*512 = 2Kͻ2*512 = 1K*/
    CH395SetSocketSendBuf(0,4,2);

    CH395SetSocketRecvBuf(1,6,4);                                     /* Socket 1 */
    CH395SetSocketSendBuf(1,10,2);

    CH395SetSocketRecvBuf(2,12,4);                                    /* Socket 2 */
    CH395SetSocketSendBuf(2,16,2);

    CH395SetSocketRecvBuf(3,18,4);                                    /* Socket 3 */
    CH395SetSocketSendBuf(3,22,2);

    CH395SetSocketRecvBuf(4,24,4);                                    /* Socket 4 */
    CH395SetSocketSendBuf(4,28,2);

    CH395SetSocketRecvBuf(5,30,4);                                    /* Socket 5 */
    CH395SetSocketSendBuf(5,34,2);

    CH395SetSocketRecvBuf(6,36,4);                                    /* Socket 6 */
    CH395SetSocketSendBuf(6,40,2);

    CH395SetSocketRecvBuf(7,42,4);                                    /* Socket 7 */
    CH395SetSocketSendBuf(7,46,2);
}

/**********************************************************************************
* Function Name  : CH395SocketInterrupt
* Description    : CH395 socket ж,ȫжб
* Input          : sockindex
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInterrupt(UINT8 sockindex)
{
   UINT8 sock_int_socket;
   UINT16 len;
   UINT16 tmp,port;

//   UINT8 Buffer[]="TMD Send from Rick and Morty!\
//                    12345678907894561230011223344!\
//                     qwertyuiopasdfghjklzxcvbnmqws!\
//                    [;];'],[.[,];',.,.,.;'[]][';,!";//120
   UINT8 Buffer0[]="TMD Send from Rick and Morty!";//30
   UINT8 Buffer1[]="12345678907894561230011223344!";//30

   sock_int_socket = CH395GetSocketInt(sockindex);                   /* ȡsocket ж״̬ */
//   printf("CH395GetSocketInt = %x\n");
   if(sock_int_socket & SINT_STAT_SENBUF_FREE)                       /* ͻУԼдҪ͵ */
   {//־λ
//       printf("send buff free!\n");

   }
   if(sock_int_socket & SINT_STAT_SEND_OK)                           /* ж */
   {
//       printf("send ok!\n");
   }
   if(sock_int_socket & SINT_STAT_RECV)                              /* ж */
   {
        len = CH395GetRecvLength(sockindex);
        if(len == 0)return;
        if(len > 512)len = 512;                                      /* MyBufferΪ512*//* ȡǰݳ */
//#if CH395_DEBUG
//       printf("receive len = %d\n",len);
//#endif
        CH395GetRecvData(sockindex,len,socket_buff[sockindex]);
        tmp = ((uint16_t)socket_buff[0][1] << 8) + socket_buff[0][0];
        port = ((uint16_t)socket_buff[0][3] << 8) + socket_buff[0][2];
        printf("sockindex = %d Data Len = %d\n",sockindex,tmp);
        printf("Port = %d\n",port);
        printf("IP = %2d.%2d.%2d.%2d\n",(uint16_t)socket_buff[0][4],(uint16_t)socket_buff[0][5],(uint16_t)socket_buff[0][6],(uint16_t)socket_buff[0][7]);
        CH395UDPSendTo(&socket_buff[0][8],(len-8),&socket_buff[0][4],port,sockindex);//أǵҪIPͬ

//        CH395UDPSendTo(Buffer0,30,MulticastIP_1,port,0);
//        CH395UDPSendTo(Buffer1,30,MulticastIP_1,port,1);

//        CH395UDPSendTo(Buffer,120,MulticastIP_1,6003,sockindex);
//        CH395UDPSendTo(Buffer0,30,MulticastIP_1,6003,sockindex);
//        Delay_Ms(50);
//        CH395UDPSendTo(Buffer1,30,MulticastIP_1,6003,sockindex);
//        Delay_Ms(50);
        return;
    }
}

/**********************************************************************************
* Function Name  : CH395GlobalInterrupt
* Description    : CH395ȫжϺ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395GlobalInterrupt(void)
{
    UINT16  init_status;
    UINT8   buf[10];

    init_status = CH395CMDGetGlobIntStatus_ALL();
    if(init_status & GINT_STAT_UNREACH)                              /* ɴжϣȡɴϢ */
    {
#if CH395_DEBUG
        printf("Init status : GINT_STAT_UNREACH\n");
#endif
        CH395CMDGetUnreachIPPT(buf);
    }
    if(init_status & GINT_STAT_IP_CONFLI)                            /* IPͻжϣ޸CH395 IPʼCH395*/
    {
    }
    if(init_status & GINT_STAT_PHY_CHANGE)                           /* PHYıж*/
    {
	    printf("Hash0:%lx\r\n",(uint32_t)Hash0);
	    printf("Hash1:%lx\r\n",(uint32_t)Hash1);
#if CH395_DEBUG
        printf("Init status : GINT_STAT_PHY_CHANGE\n");
#endif
    }
    if(init_status & GINT_STAT_SOCK0)
    {
        CH395SocketInterrupt(0);                                     /* socket 0ж*/
    }
    if(init_status & GINT_STAT_SOCK1)
    {
        CH395SocketInterrupt(1);                                     /* socket 1ж*/
    }
    if(init_status & GINT_STAT_SOCK2)
    {
        CH395SocketInterrupt(2);                                     /* socket 2ж*/
    }
    if(init_status & GINT_STAT_SOCK3)
    {
        CH395SocketInterrupt(3);                                     /* socket 3ж*/
    }
    if(init_status & GINT_STAT_SOCK4)
    {
        CH395SocketInterrupt(4);                                     /* socket 4ж*/
    }
    if(init_status & GINT_STAT_SOCK5)
    {
        CH395SocketInterrupt(5);                                     /* socket 5ж*/
    }
    if(init_status & GINT_STAT_SOCK6)
    {
        CH395SocketInterrupt(6);                                     /* socket 6ж*/
    }
    if(init_status & GINT_STAT_SOCK7)
    {
        CH395SocketInterrupt(7);                                     /* socket 7ж*/
    }
}

/*********************************************************************************
* Function Name  : CH395Init
* Description    : CH395IP,GWIP,MACȲʼ
* Input          : None
* Output         : None
* Return         : ִн
**********************************************************************************/
UINT8  CH395Init(void)
{
    UINT8 i;

    i = CH395CMDCheckExist(0x65);
    if(i != 0x9a)return CH395_ERR_UNKNOW;                            /* ޷ͨ0XFA */
                                                                     /* 0XFAһΪӲ߶дʱ򲻶 */
#if (CH395_OP_INTERFACE_MODE == 2)
#ifdef UART_WORK_BAUDRATE
    CH395CMDSetUartBaudRate(UART_WORK_BAUDRATE);                     /* ò */
    Delay_Ms(1);
#endif
#endif
    CH395CMDSetIPAddr(CH395Inf.IPAddr);                              /* CH395IPַ */
    CH395CMDSetGWIPAddr(CH395Inf.GWIPAddr);                          /* صַ */
    CH395CMDSetMASKAddr(CH395Inf.MASKAddr);                          /* 룬ĬΪ255.255.255.0*/
    Delay_Ms(10);
    i = CH395CMDInitCH395();                                         /* ʼCH395оƬ */
    return i;
}

/**********************************************************************************
* Function Name  : main
* Description    : main
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/

int main(void)
{
    UINT8 i;
    UINT8 MacCrc32;


    Delay_Init();
    USART_Printf_Init(115200);
#if CH395_DEBUG
    printf("CH395EVT Test Demo\n");
#endif
    CH395_PORT_INIT();                                               /* ʼƬ */
    CH395CMDReset();                                                 /* λCH395оƬ */
    Delay_Ms(1000);                                                  /* ʱ1000,ҪֿдЧ */
    Delay_Ms(1000);
    i = CH395CMDGetVer();                                            /*ȡоƬԼ̼汾 */
    printf("CH395CMDGetVer:%x\n",i);
    InitCH395InfParam();                                             /* ʼCH395ر */
    i = CH395Init();                                                 /* ʼCH395оƬ */
    printf("CH395Init:%x\n",i);
    mStopIfError(i);                                                 /*ʹãʾ룬ͣ*/

    MacCrc32 =  CH395CRCRet6Bit(MultiMac_1);
    printf("MacCrc32 : %2x\n",(uint16_t)MacCrc32);
    if(MacCrc32 > 31)
    {
        MacCrc32 -=32;
        printf("MacCrc32_1 : %2x\n",(uint16_t)MacCrc32);
        Hash1 = Hash1|((uint32_t)1<<MacCrc32);
    }
    else
    {
        Hash0 |= ((uint32_t)1<<MacCrc32);
    }
    printf("Hash0:%lx\r\n",(uint32_t)Hash0);
    printf("Hash1:%lx\r\n",(uint32_t)Hash1);
    CH395CMDSetMACFilt(0x1d, Hash0, Hash1);

    MacCrc32 =  CH395CRCRet6Bit(MultiMac_2);
    printf("MacCrc32 : %2x\n",(uint16_t)MacCrc32);
    if(MacCrc32 > 31)
    {
        MacCrc32 -=32;
        printf("MacCrc32_2 : %2x\n",(uint16_t)MacCrc32);
        Hash1 = Hash1|((uint32_t)1<<MacCrc32);
    }
    else
    {
        Hash0 |= ((uint32_t)1<<MacCrc32);
    }
    printf("Hash0:%lx\r\n",(uint32_t)Hash0);
    printf("Hash1:%lx\r\n",(uint32_t)Hash1);
    CH395CMDSetMACFilt(0x1d, Hash0, Hash1);

	while(1)
    {                                                                /* ȴ̫ӳɹ*/
       if(CH395CMDGetPHYStatus() == PHY_DISCONN)                     /* ѯCH395Ƿ */
       {
           Delay_Ms(200);                                            /* δȴ200MSٴβѯ */
           
       }
       else
       {
#if CH395_DEBUG
           printf("CH395 Connect Ethernet\n");                       /* CH395оƬӵ̫ʱж */
#endif
           break;
       }
    }
	InitSocketParam();                                               /* ʼsocketر */
	CH395SocketInitOpen();
	while(1)
	{
	    if(CH395_INT_WIRE==RESET)                                    /* жŵƽ仯ȫж */
		{
	        CH395GlobalInterrupt();
		}
	}
}

